"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
/*
	intro : date handle functions defination
	Author : chenchao
	Date : 2018-10-30 
*/
var date = new Date();

var dateUtils = {

	// get temp year
	year: date.getFullYear() * 1,
	month: date.getMonth() * 1 + 1, // month should add 1 
	date: date.getDate() * 1,
	day: date.getDay() * 1,
	// offset some date
	offsetSomeYear: function offsetSomeYear() {
		var offset = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
		var year = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.year;

		return year + offset * 1;
	},
	offsetSomeMonth: function offsetSomeMonth() {
		var offset = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
		var month = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.month;

		var tm = (month + offset * 1) % 12;
		return tm === 0 ? 12 : tm;
	},
	offsetSomeDay: function offsetSomeDay() {
		var day = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.day;
		var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

		return (day + offset * 1) % 7;
	},

	// offset month get full date , link XXXX-MM-DD
	// offsetMonth(year = this.year , month = this.month , offset = 0){
	// 	if()

	// 	return 
	// } ,
	// cal two date's month range
	calRangeMonthNum: function calRangeMonthNum(aimDate, comDate) {
		var aimArr = aimDate.split("-");
		var comArr = comDate.split("-");
		return (aimArr[0] * 1 - comArr[0] * 1) * 12 + (aimArr[1] * 1 - comArr[1] * 1);
	},

	// judge month first date is which day
	getMonthFirstDay: function getMonthFirstDay() {
		var year = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.year;
		var month = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.month;

		return new Date(year, month * 1 - 1, 1).getDay();
	},

	// get month end day
	// @month - should +1 , 
	getMonthEndDay: function getMonthEndDay() {
		var year = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.year;
		var month = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.month;

		return new Date(year, month, 1 - 1).getDate();
	},

	// get picker array from one month
	// aimed to get a array of days of one month 
	getPickerArrayMap: function getPickerArrayMap() {
		var month = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.month;
		var year = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.year;

		var am = [];
		// end date of one month
		var endDate = this.getMonthEndDay(year, month);
		// first day of one month
		var firstDay = this.getMonthFirstDay(year, month);

		for (var i = 1; i <= endDate; i++) {
			am.push({
				year: year,
				month: month,
				date: i,
				day: (firstDay + i - 1) % 7,
				tempChoose: true,
				isToday: year + "-" + month + "-" + i === this.year + "-" + this.month + "-" + this.date
			});
		}
		// aim
		/*
  	{
  		year : 2018 ,
  		month : 10 ,
  		date : 10 ,
  		day : 6
  	}
  */
		return am;
	},

	// supplement render picker
	supplementPickerArrayMap: function supplementPickerArrayMap() {
		var month = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.month;
		var year = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.year;

		var bArr = [];
		var nArr = [];
		var am = this.getPickerArrayMap(month, year);
		var length = am.length;
		// before verb
		var bYear = month * 1 === 1 ? year * 1 - 1 : year * 1;
		var bMonth = this.offsetSomeMonth(-1, month);
		var bOffset = am[0]['day'] * 1;
		var bMonthEndDay = this.getMonthEndDay(bYear, bMonth);
		// next verb
		var nYear = month * 1 === 12 ? year * 1 + 1 : year * 1;
		var nMonth = this.offsetSomeMonth(1, month);
		var nOffset = am[length - 1]['day'] * 1;
		// supplement before array
		for (var i = 0; i < bOffset; i++) {
			bArr.push({
				year: bYear,
				month: bMonth,
				date: bMonthEndDay - (bOffset - i) + 1,
				day: i,
				tempChoose: false
			});
		}
		// supplement next array
		var j = 1;
		var isFullRange = bArr.length + am.length > 35;
		var maxRange = isFullRange ? 6 : 13;
		for (var _i = nOffset + 1; _i <= maxRange; _i++) {
			nArr.push({
				year: nYear,
				month: nMonth,
				date: j++,
				day: _i % 7,
				tempChoose: false
			});
		}
		return bArr.concat(am).concat(nArr);
	}
};
exports.default = dateUtils;