"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _base = require("./base.js");

var _base2 = _interopRequireDefault(_base);

var _index = require("../../g-icon/src/index");

var _index2 = _interopRequireDefault(_index);

require("./index.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               	intro : GMenu Column Component defination
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               	Author : chenchao
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               	Date : 2018-10-25
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               */


// top menu
var CLOSE = 'close';
var OPEN = 'open';

// children menu
var ACTIVE = 'active';
var NOT_ACTIVE = '';

// target enmu
var SELF = '_self';

var GMenuColumn = function (_Base) {
	_inherits(GMenuColumn, _Base);

	function GMenuColumn() {
		_classCallCheck(this, GMenuColumn);

		var _this = _possibleConstructorReturn(this, (GMenuColumn.__proto__ || Object.getPrototypeOf(GMenuColumn)).call(this));

		_this.layout = 'column';
		_this.state = {
			menu: [],
			active: ''
		};
		return _this;
	}

	_createClass(GMenuColumn, [{
		key: "componentWillReceiveProps",
		value: function componentWillReceiveProps(nextProps) {
			var _nextProps$menu = nextProps.menu,
			    menu = _nextProps$menu === undefined ? [] : _nextProps$menu,
			    _nextProps$active = nextProps.active,
			    active = _nextProps$active === undefined ? '' : _nextProps$active;

			this.setState({ menu: this.initMenu(true, [].concat(menu)) });
		}
	}, {
		key: "componentDidMount",
		value: function componentDidMount() {
			// active 默认值为 window.location.href
			var _props = this.props,
			    _props$menu = _props.menu,
			    menu = _props$menu === undefined ? [] : _props$menu,
			    _props$active = _props.active,
			    active = _props$active === undefined ? '' : _props$active;

			if (active === '') active = window.location.href;
			this.setState({ menu: this.initMenu(true, [].concat(menu), active) });
		}
		/*
  	intro : jump To TopMenu Link
  */

	}, {
		key: "jumpToTopMenuLink",
		value: function jumpToTopMenuLink(index) {
			var link = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
			var target = arguments[2];

			// if has link , jump to link
			if (this.openLink(link, target)) {
				var menu = this.initMenu(false, [].concat(this.state.menu));
				if (menu[index]) menu[index]['isActive'] = ACTIVE;
				var _props$opentype = this.props.opentype,
				    opentype = _props$opentype === undefined ? 'mult' : _props$opentype;

				if (opentype === 'single' && menu[index]['isOpen'] === CLOSE) {
					menu.map(function (item) {
						item['isOpen'] = CLOSE;return item;
					});
				}
				this.setState({ menu: [].concat(menu) });
				return true;
			}
			return false;
		}
		/*
  	intro : bind top Menu Click
  */

	}, {
		key: "bindTopMenuClick",
		value: function bindTopMenuClick(ev, index) {
			var link = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
			var target = arguments[3];

			// if has link , jump to link
			if (this.jumpToTopMenuLink(index, link, target)) return;
			// not link 
			var menu = [].concat(this.state.menu);
			var _props$opentype2 = this.props.opentype,
			    opentype = _props$opentype2 === undefined ? 'mult' : _props$opentype2;

			if (opentype === 'single' && menu[index]['isOpen'] === CLOSE) {
				menu.map(function (item) {
					item['isOpen'] = CLOSE;return item;
				});
			}
			if (menu[index]) menu[index]['isOpen'] = menu[index]['isOpen'] === OPEN ? CLOSE : OPEN;
			// TODO 区分 opentype
			this.setState({ menu: [].concat(menu) });
		}

		/*
  	intro : bind subMenu Click
  */

	}, {
		key: "bindSubMenuClick",
		value: function bindSubMenuClick(ev, index, topIndex, link, target) {
			var _this2 = this;

			// init menu
			var menu = this.initMenu(false, [].concat(this.state.menu));
			var _props$opentype3 = this.props.opentype,
			    opentype = _props$opentype3 === undefined ? 'mult' : _props$opentype3;

			if (opentype === 'single' && menu[topIndex]['isOpen'] === CLOSE) {
				menu.map(function (item) {
					item['isOpen'] = CLOSE;return item;
				});
			}
			if (menu[topIndex]) menu[topIndex]['isOpen'] = OPEN;
			if (menu[topIndex]['subChild'][index]) menu[topIndex]['subChild'][index]['isActive'] = ACTIVE;
			// TODO 区分 opentype
			this.setState({ menu: [].concat(menu) }, function () {
				// if has link , jump to link
				_this2.openLink(link, target);
			});
		}

		/*
  	intro : bindMenuChange
  */

	}, {
		key: "bindMenuChange",
		value: function bindMenuChange(ev, link, target, index, topIndex, subIndex) {
			var _this3 = this;

			var menu = this.initMenu(false, [].concat(this.state.menu));
			// doesn't has subIndex
			if ((typeof subIndex === "undefined" ? "undefined" : _typeof(subIndex)).toLowerCase() === 'undefined') {
				menu[topIndex]['children'][index]['isActive'] = ACTIVE;
			}
			// has subIndex means - has subChild
			if ((typeof subIndex === "undefined" ? "undefined" : _typeof(subIndex)).toLowerCase() !== 'undefined') {
				menu[topIndex]['subChild'][subIndex]['children'][index]['isActive'] = ACTIVE;
			}
			this.setState({ menu: menu }, function () {
				// jump to link
				_this3.openLink(link, target);
			});
		}
		/*
  	intro : render local top menu
  */

	}, {
		key: "renderLocalTopMenu",
		value: function renderLocalTopMenu() {
			var _this4 = this;

			var menuItem = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
			var index = arguments[1];
			var _menuItem$text = menuItem.text,
			    text = _menuItem$text === undefined ? '' : _menuItem$text,
			    _menuItem$isOpen = menuItem.isOpen,
			    isOpen = _menuItem$isOpen === undefined ? '' : _menuItem$isOpen,
			    _menuItem$icon = menuItem.icon,
			    icon = _menuItem$icon === undefined ? '' : _menuItem$icon,
			    _menuItem$target = menuItem.target,
			    target = _menuItem$target === undefined ? SELF : _menuItem$target,
			    _menuItem$link = menuItem.link,
			    link = _menuItem$link === undefined ? '' : _menuItem$link,
			    _menuItem$isActive = menuItem.isActive,
			    isActive = _menuItem$isActive === undefined ? '' : _menuItem$isActive;

			var islink = this.authLink(link) ? true : false;
			return _react2.default.createElement(
				"p",
				{ className: "t-g-menu-item-title link-" + islink + " " + isOpen + " active-" + isActive, onClick: function onClick(ev) {
						_this4.bindTopMenuClick(ev, index, link, target);
					} },
				icon && icon !== '' && _react2.default.createElement(_index2.default, { type: icon }),
				_react2.default.createElement(
					"span",
					{ style: { marginLeft: 8 } },
					text
				),
				_react2.default.createElement(
					"span",
					{ className: "t-g-menu-item-title-icon" },
					_react2.default.createElement(_index2.default, { type: isOpen === 'open' ? 'arrow-up-s' : 'arrow-down-s' })
				)
			);
		}
	}, {
		key: "render",
		value: function render() {
			var _this5 = this;

			var _props2 = this.props,
			    _props2$extraClass = _props2.extraClass,
			    extraClass = _props2$extraClass === undefined ? '' : _props2$extraClass,
			    _props2$active = _props2.active,
			    active = _props2$active === undefined ? '' : _props2$active,
			    _props2$theme = _props2.theme,
			    theme = _props2$theme === undefined ? 'light' : _props2$theme;
			var _state$menu = this.state.menu,
			    menu = _state$menu === undefined ? [] : _state$menu;

			return _react2.default.createElement(
				"div",
				{ className: "t-g-menu-con t-g-menu-con-column theme-" + theme },
				menu && menu.map(function (item, index) {
					return _this5.renderTopMenu(item, index);
				})
			);
		}
	}]);

	return GMenuColumn;
}(_base2.default);

exports.default = GMenuColumn;