"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
var _arguments = arguments;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     	intro : message component defination
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     	Author : chenchao
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     	Date : 2020-04-23
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     */


var _reactPureCheck = require("react-pure-check");

var _functionComUtils = require("function-com-utils");

var _dom = require("../../g-utils/dom");

var _dom2 = _interopRequireDefault(_dom);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var GMessageFun = function () {
	function GMessageFun() {
		var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

		_classCallCheck(this, GMessageFun);

		this.pushCount = 0;
		this.options = Object.assign({}, this.getDefaultOptions(), options);
		if ((0, _reactPureCheck.Types)(GMessageFun.unique) !== "undefined") {
			return GMessageFun.unique;
		}
		GMessageFun.unique = this;
	}
	/*
 	intro : get default options
 */


	_createClass(GMessageFun, [{
		key: "getDefaultOptions",
		value: function getDefaultOptions() {
			return {
				closeTime: 1500,
				messageIcon: {
					style: {
						position: "relative",
						top: "3px",
						display: "inline-block",
						height: "15px",
						width: "15px",
						marginRight: "6px",
						background: "url(//pic1.58cdn.com.cn/nowater/cxnomark/n_v2afb4f28859b74bd1b1e7c62b9d0f4bed.png) no-repeat",
						backgroundSize: "cover"
					}
				},
				messageConstructor: {
					style: {
						position: "fixed",
						zIndex: 199,
						display: "inline-block",
						padding: "10px 16px",
						background: "#fff",
						borderRadius: "2px",
						top: "-50px",
						left: "50%",
						pointerEvents: "all",
						fontSize: "13px",
						backgroundColor: "#fff",
						boxShadow: "0 3px 6px -4px rgba(0,0,0,.12), 0 6px 16px 0 rgba(0,0,0,.08), 0 9px 28px 8px rgba(0,0,0,.05)",
						transition: "all .5s ease",
						opacity: ".5",
						marginTop: "-50px",
						transform: "translateX(-50%)" // 兼容性
					}
				}
			};
		}
		/*
  	intro : add push count
  */

	}, {
		key: "addCount",
		value: function addCount() {
			this.pushCount++;
			clearTimeout(this.removeTime);
		}
		/*
  	intro : reduce push count , if count had been 0 , main container would be removed after 10000ms
  */

	}, {
		key: "reduceCount",
		value: function reduceCount() {
			if (--this.pushCount > 0) return false;
			// this.removeTime = setTimeout(() => {
			// 	clearTimeout(this.removeTime) ; 
			// 	this.clearContainer() ;
			// } , 10000) ;
		}
		/*
  	intro : set message icon
  */

	}, {
		key: "setMessageIcon",
		value: function setMessageIcon(type) {
			var leftOpt = 0;
			switch (type) {
				case "success":
					leftOpt = "-30px";
					break;
				case "warning":
					leftOpt = "-15px";
					break;
				case "error":
					leftOpt = "-75px";
					break;
				case "info":
				default:
					leftOpt = "-45px";
					break;
			}
			var iconDom = _dom2.default.createDom("span");
			_dom2.default.setStyle(iconDom, Object.assign({}, this.options.messageIcon.style, { backgroundPositionX: "" + leftOpt }));
			return iconDom;
		}
		/*
  	intro : set message constructor
  */

	}, {
		key: "setMessageConstructor",
		value: function setMessageConstructor(message, type) {
			var count = this.pushCount;
			var messageDom = _dom2.default.createDom("p");
			_dom2.default.setStyle(messageDom, this.options.messageConstructor.style || {});

			// add icon
			var iconDom = this.setMessageIcon(type);
			messageDom.appendChild(iconDom);

			// add message
			var contentDom = _dom2.default.createDom("span");
			contentDom.innerText = message;
			messageDom.appendChild(contentDom);

			window.document.body.appendChild(messageDom);
			this.setAnimation(messageDom, count);
		}
		/*
  	intro : set animation
  */

	}, {
		key: "setAnimation",
		value: function setAnimation(animationDom, count) {
			var _this = this;

			var closeTime = this.options.closeTime;
			// init  marginTop

			new Promise(function (resolve, reject) {
				var interval = setTimeout(function () {
					animationDom.style.marginTop = 50 + count * 1 * 50 + "px";
					animationDom.style.opacity = "1";
					resolve();
					clearTimeout(interval);
				}, 200);
			}).then(function () {
				_this.closeMessageItem(animationDom, closeTime, count);
			});
		}
		/*
  	intro : close item
  */

	}, {
		key: "closeMessageItem",
		value: function closeMessageItem(animationDom) {
			var _this2 = this;

			var newCloseTime = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 100;
			var count = arguments[2];

			new Promise(function (resolve, reject) {
				var delayTime = setTimeout(function () {
					animationDom.style.marginTop = count * 1 * 50 - 20 + "px";
					animationDom.style.opacity = "0.5";
					resolve();
					clearTimeout(delayTime);
				}, newCloseTime);
			}).then(function () {
				var closeTime = setTimeout(function () {
					var body = window.document.body;
					if (_dom2.default.contains(body, animationDom)) {
						body.removeChild(animationDom);
						_this2.reduceCount();
					}
					clearTimeout(closeTime);
				}, 200);
			});
		}
		/*
  	intro : push message
  */

	}, {
		key: "pushMessage",
		value: function pushMessage() {
			var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
			var type = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "info";

			if (arguments.length < 1 || (0, _reactPureCheck.Types)(message) !== "string") {
				(0, _functionComUtils.errorLog)("you should offer a %s for message", "string");
				return false;
			}
			this.addCount();
			// set message
			this.setMessageConstructor(message, type);
		}

		/*
  	intro : success
  */

	}, {
		key: "success",
		value: function success() {
			var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

			return this.pushMessage(message, "success");
		}
		/*
  	intro : info
  */

	}, {
		key: "info",
		value: function info() {
			var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

			return this.pushMessage(message, "info");
		}
		/*
  	intro : warning
  */

	}, {
		key: "warning",
		value: function warning() {
			var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

			return this.pushMessage(message, 'warning');
		}
		/*
  	intro : error
  */

	}, {
		key: "error",
		value: function error() {
			var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

			return this.pushMessage(message, 'error');
		}
		/*
  	intro : destory instance
  */

	}, {
		key: "destory",
		value: function destory() {
			GMessageFun.unique = null;
		}
	}]);

	return GMessageFun;
}();

;

var GMessage = function GMessage() {
	var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

	if (_arguments.length > 0 && (0, _reactPureCheck.Types)(options) !== "object") {
		(0, _functionComUtils.errorBreak)("you should offer a %s for options", "object");
		return false;
	}
	return new GMessageFun(options);
};

exports.default = GMessage;