"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactPureCheck = require("react-pure-check");

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _index = require("../../g-icon/src/index");

var _index2 = _interopRequireDefault(_index);

var _index3 = require("../../g-button/src/index");

var _index4 = _interopRequireDefault(_index3);

require("./index.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               	intro : search input component
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               	Author : chenchao
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               	Date : 2018-08-13
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               */

var TIME_OUT = 300;

var GSearchInput = function (_Component) {
	_inherits(GSearchInput, _Component);

	function GSearchInput(props) {
		_classCallCheck(this, GSearchInput);

		var _this = _possibleConstructorReturn(this, (GSearchInput.__proto__ || Object.getPrototypeOf(GSearchInput)).call(this, props));

		_this.bindInputKeyDown = function (ev) {
			_this.props.keyDown && _this.props.keyDown(_this.state.inputValue);
			if (ev.keyCode * 1 === 13) {
				_this.props.search && _this.props.search(_this.state.inputValue);
			}
		};

		_this.bindInputChange = function (ev) {
			ev.persist();
			_this.setState({
				inputValue: ev.target.value || ''
			}, function () {
				_this.props.change && _this.props.change(ev.target.value || '');
			});
		};

		_this.bindSearchFun = function (ev) {
			// 截流
			if (!_this.searchFlag) return;
			// logic
			_this.props.search && _this.props.search(_this.state.inputValue);
			_this.searchFlag = false;
			var t = setTimeout(function () {
				_this.searchFlag = true;
				clearTimeout(t);
			}, TIME_OUT);
		};

		_this.searchFlag = true;
		_this.state = {
			inputValue: props.defaultValue || ""
		};
		return _this;
	}

	_createClass(GSearchInput, [{
		key: "shouldComponentUpdate",
		value: function shouldComponentUpdate(nextProps, nextState) {
			return !(0, _reactPureCheck.WhetherEqual)(nextProps, this.props) || !(0, _reactPureCheck.WhetherEqual)(nextState, this.state);
		}
	}, {
		key: "componentWillReceiveProps",
		value: function componentWillReceiveProps(nextProps) {
			if (nextProps.hasOwnProperty('value')) {
				var _nextProps$value = nextProps.value,
				    value = _nextProps$value === undefined ? '' : _nextProps$value;

				this.setState({ inputValue: value });
			}
		}
		/*
  	intro : bindInputKeyDown
  */

		/*
  	intro : bindInputChange
  */

		/*
  	intro : bindSearchFun
  */

	}, {
		key: "renderSearchInput",

		/*
  	render search input
  */
		value: function renderSearchInput() {
			var _props = this.props,
			    _props$width = _props.width,
			    width = _props$width === undefined ? '' : _props$width,
			    _props$placeholder = _props.placeholder,
			    placeholder = _props$placeholder === undefined ? '请输入' : _props$placeholder;
			var _state$inputValue = this.state.inputValue,
			    inputValue = _state$inputValue === undefined ? '' : _state$inputValue;

			return _react2.default.createElement("input", {
				style: { width: width },
				placeholder: placeholder,
				value: inputValue,
				onKeyDown: this.bindInputKeyDown,
				onChange: this.bindInputChange });
		}
		/*
  	render search text
  */

	}, {
		key: "renderSearchText",
		value: function renderSearchText() {
			var _props2 = this.props,
			    _props2$extraClass = _props2.extraClass,
			    extraClass = _props2$extraClass === undefined ? '' : _props2$extraClass,
			    _props2$searching = _props2.searching,
			    searching = _props2$searching === undefined ? true : _props2$searching,
			    _props2$border = _props2.border,
			    border = _props2$border === undefined ? true : _props2$border,
			    _props2$searchText = _props2.searchText,
			    searchText = _props2$searchText === undefined ? "" : _props2$searchText;

			return _react2.default.createElement(
				"div",
				{ className: "t-search-input-text-con" },
				_react2.default.createElement(
					"div",
					{ className: extraClass + " t-search-input-con border-" + border },
					_react2.default.createElement(_index2.default, { type: "search" }),
					this.renderSearchInput()
				),
				_react2.default.createElement(
					"span",
					{ className: "t-search-input-font" },
					_react2.default.createElement(
						_index4.default,
						{ click: this.bindSearchFun },
						searchText
					)
				)
			);
		}
	}, {
		key: "render",
		value: function render() {
			var _props3 = this.props,
			    _props3$extraClass = _props3.extraClass,
			    extraClass = _props3$extraClass === undefined ? '' : _props3$extraClass,
			    _props3$searching = _props3.searching,
			    searching = _props3$searching === undefined ? true : _props3$searching,
			    _props3$border = _props3.border,
			    border = _props3$border === undefined ? true : _props3$border,
			    _props3$searchText = _props3.searchText,
			    searchText = _props3$searchText === undefined ? "" : _props3$searchText;
			// let isPlaceholder = inputValue === '' ;
			// 	{ isPlaceholder && <span className="t-search-input-placeholder">{placeholder}</span>  }

			if (searchText !== '') {
				return _react2.default.createElement(
					"span",
					null,
					this.renderSearchText()
				);
			}
			return _react2.default.createElement(
				"div",
				{ className: extraClass + " t-search-input-con border-" + border },
				this.renderSearchInput(),
				searching && _react2.default.createElement(_index2.default, { type: "search", click: this.bindSearchFun })
			);
		}
	}]);

	return GSearchInput;
}(_react.Component);
// type check


GSearchInput.propTypes = {
	searching: _propTypes2.default.bool,
	border: _propTypes2.default.bool
};
exports.default = GSearchInput;