"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactPureCheck = require("react-pure-check");

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _index = require("../../g-search-input/src/index");

var _index2 = _interopRequireDefault(_index);

require("./index.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               	intro : GSelect component defination
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               	Author : chenchao
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               	Date : 2018-08-10
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               */


// static
var KEYNAME = 'text';
var VALUENAME = 'value';

var GSelect = function (_Component) {
	_inherits(GSelect, _Component);

	function GSelect() {
		_classCallCheck(this, GSelect);

		var _this = _possibleConstructorReturn(this, (GSelect.__proto__ || Object.getPrototypeOf(GSelect)).call(this));

		_this.setSelectShow = function (show) {
			var t = setTimeout(function () {
				_this.setState({ show: show });
				clearTimeout(t);
			}, 100);
		};

		_this.bindSelectShow = function (ev) {
			if (!ev.target) return;
			_this.setSelectShow(!_this.state.show);
		};

		_this.bindFilterChange = function () {
			var filterStr = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
			var _this$props = _this.props,
			    _this$props$keyName = _this$props.keyName,
			    keyName = _this$props$keyName === undefined ? KEYNAME : _this$props$keyName,
			    _this$props$remoteFil = _this$props.remoteFilter,
			    remoteFilter = _this$props$remoteFil === undefined ? void 0 : _this$props$remoteFil;
			// remote filter

			if (remoteFilter && (typeof remoteFilter === "undefined" ? "undefined" : _typeof(remoteFilter)).toLowerCase() === 'function') {
				// trigger select , but return a empty string
				// this.props.select && this.props.select("" , {}) ;
				_this.props.remoteFilter && _this.props.remoteFilter(filterStr);
				return;
			}
			// local filter
			var _this$props$list = _this.props.list,
			    list = _this$props$list === undefined ? [] : _this$props$list;

			_this.setState({ text: filterStr, list: list.filter(function (item) {
					return item[keyName].indexOf(filterStr) >= 0;
				}) });
		};

		_this.bindSelectClick = function (ev) {
			if (!ev.target) return;
			var _this$props2 = _this.props,
			    _this$props2$keyName = _this$props2.keyName,
			    keyName = _this$props2$keyName === undefined ? KEYNAME : _this$props2$keyName,
			    _this$props2$valueNam = _this$props2.valueName,
			    valueName = _this$props2$valueNam === undefined ? VALUENAME : _this$props2$valueNam,
			    _this$props2$list = _this$props2.list,
			    list = _this$props2$list === undefined ? [] : _this$props2$list;

			var tempVl = ev.target.getAttribute("data-value") || '',
			    text = ev.target.getAttribute("data-text") || '';
			_this.setState({
				active: tempVl,
				text: text
			}, function () {
				// TODO 
				// when you pick one choose , all list should be given
				// 300's delay is based on your select flod or open animation time
				var t = setTimeout(function () {
					_this.setState({ list: list });clearTimeout(t);
				}, 200);
				var obj = {};
				obj[keyName] = text;
				obj[valueName] = tempVl;
				_this.props.select && _this.props.select(tempVl, obj);
			});
		};

		_this.state = {
			active: '',
			text: '',
			list: [],
			show: false
		};
		return _this;
	}

	_createClass(GSelect, [{
		key: "shouldComponentUpdate",
		value: function shouldComponentUpdate(nextProps, nextState) {
			return !(0, _reactPureCheck.WhetherEqual)(nextProps, this.props) || !(0, _reactPureCheck.WhetherEqual)(nextState, this.state);
		}
	}, {
		key: "componentWillReceiveProps",
		value: function componentWillReceiveProps(nextProps) {
			if (!nextProps.hasOwnProperty('active')) return;
			var _nextProps$active = nextProps.active,
			    active = _nextProps$active === undefined ? '' : _nextProps$active,
			    _nextProps$list = nextProps.list,
			    list = _nextProps$list === undefined ? [] : _nextProps$list;

			this.initActive(active, list);
		}
	}, {
		key: "componentDidMount",
		value: function componentDidMount() {
			var _props = this.props,
			    _props$active = _props.active,
			    active = _props$active === undefined ? '' : _props$active,
			    _props$list = _props.list,
			    list = _props$list === undefined ? '' : _props$list;

			this.initActive(active, list);
		}
		/*
  	init active
  */

	}, {
		key: "initActive",
		value: function initActive() {
			var active = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
			var list = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

			var text = '';
			// pick text
			if (active !== '') {
				list.map(function (item) {
					if (item.value === active) {
						text = item.text;
					}
				});
			}
			this.setState({ active: active, text: text, list: list });
		}
		/*
  	intro : bindSelectShow
  	@aimValue - aim value 
  */

		/*
  	intro : bind filter change
  	@value : { input change return value } 
  */

		/*
  	intro : bindSelectClick
  */

	}, {
		key: "renderFilter",

		/*
  	intro : filter render
  */
		value: function renderFilter() {
			var _this2 = this;

			var _props$placeholder = this.props.placeholder,
			    placeholder = _props$placeholder === undefined ? '请输入' : _props$placeholder;
			var _state$text = this.state.text,
			    text = _state$text === undefined ? '' : _state$text;

			var isShowHolder = text === '' ? true : false;
			return _react2.default.createElement(_index2.default, {
				extraClass: "t-g-select-input-reset",
				placeholder: placeholder,
				value: text,
				change: function change(value) {
					_this2.bindFilterChange(value);
				}
				// width='100%'
				, border: false,
				searching: false });
		}
		/*
  	intro : normal render
  */

	}, {
		key: "renderNormal",
		value: function renderNormal() {
			var _props$placeholder2 = this.props.placeholder,
			    placeholder = _props$placeholder2 === undefined ? '请选择' : _props$placeholder2;
			var _state$text2 = this.state.text,
			    text = _state$text2 === undefined ? '' : _state$text2;

			var isShowHolder = text === '' ? true : false;
			return _react2.default.createElement(
				"p",
				{ className: "t-g-select-text place-" + isShowHolder },
				isShowHolder ? placeholder : text
			);
		}

		/*
  	intro : render select list
  */

	}, {
		key: "renderSelectList",
		value: function renderSelectList() {
			var _this3 = this;

			// props control
			var _props2 = this.props,
			    _props2$keyName = _props2.keyName,
			    keyName = _props2$keyName === undefined ? KEYNAME : _props2$keyName,
			    _props2$valueName = _props2.valueName,
			    valueName = _props2$valueName === undefined ? VALUENAME : _props2$valueName;

			// state control

			var _state = this.state,
			    _state$active = _state.active,
			    active = _state$active === undefined ? '' : _state$active,
			    _state$list = _state.list,
			    list = _state$list === undefined ? [] : _state$list,
			    _state$show = _state.show,
			    show = _state$show === undefined ? false : _state$show;

			return _react2.default.createElement(
				"div",
				{ className: "t-g-select-list-con show-" + show },
				list.length === 0 && _react2.default.createElement(
					"p",
					{ className: "t-g-select-item" },
					"\u6682\u65E0\u6570\u636E"
				),
				list && list.map(function (item) {
					var isActive = active + '' === item[valueName] + '' ? 'active' : '';
					return _react2.default.createElement(
						"p",
						{
							title: item[keyName],
							className: "t-g-select-item " + isActive,
							"data-value": item[valueName],
							"data-text": item[keyName],
							onClick: _this3.bindSelectClick,
							key: item[valueName] },
						item[keyName]
					);
				})
			);
		}
	}, {
		key: "render",
		value: function render() {
			var _this4 = this;

			var _props3 = this.props,
			    _props3$extraClass = _props3.extraClass,
			    extraClass = _props3$extraClass === undefined ? '' : _props3$extraClass,
			    _props3$filterable = _props3.filterable,
			    filterable = _props3$filterable === undefined ? false : _props3$filterable,
			    _props3$width = _props3.width,
			    width = _props3$width === undefined ? '' : _props3$width,
			    _props3$position = _props3.position,
			    position = _props3$position === undefined ? 'bottom' : _props3$position;
			var _state$show2 = this.state.show,
			    show = _state$show2 === undefined ? false : _state$show2;

			return _react2.default.createElement(
				"span",
				{ className: "" + extraClass },
				_react2.default.createElement("div", {
					className: "t-g-select-bg show-" + show,
					onClick: function onClick(ev) {
						_this4.setSelectShow(false);
					} }),
				_react2.default.createElement(
					"div",
					{
						className: "t-g-select-con show-" + show + " position-" + position,
						onClick: this.bindSelectShow,
						style: { width: width } },
					filterable ? this.renderFilter() : this.renderNormal(),
					this.renderSelectList()
				)
			);
		}
	}]);

	return GSelect;
}(_react.Component);

// type check


GSelect.propTypes = {
	filterable: _propTypes2.default.bool,
	position: _propTypes2.default.string
};

exports.default = GSelect;