"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     	intro : toast message defination
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     	Author : chenchao
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     	Date : 2019-06-20
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     */


var _reactPureCheck = require("react-pure-check");

var _functionComUtils = require("function-com-utils");

var _dom = require("../../g-utils/dom");

var _dom2 = _interopRequireDefault(_dom);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var GToastFun = function () {
	function GToastFun(options) {
		_classCallCheck(this, GToastFun);

		this.backgroundContainer = null;
		this.options = Object.assign({}, this.getDefaultOptions(), options);
		if ((0, _reactPureCheck.Types)(GToastFun.unique) !== "undefined") {
			return GToastFun.unique;
		}
		GToastFun.unique = this;
	}
	/*
 	intro : get default options
 */


	_createClass(GToastFun, [{
		key: "getDefaultOptions",
		value: function getDefaultOptions() {
			var _style;

			return {
				closeTime: 2500,
				backgroundContainer: {
					style: {
						position: "fixed",
						top: "0",
						left: "0",
						bottom: "0",
						right: "0",
						textAlign: "center",
						zIndex: 199
					}
				},
				contentContainer: {
					style: (_style = {
						position: "absolute",
						overflow: "hidden",
						maxWidth: "20%"
					}, _defineProperty(_style, "overflow", "hidden"), _defineProperty(_style, "top", "50%"), _defineProperty(_style, "margin", 0), _defineProperty(_style, "padding", "10px 20px"), _defineProperty(_style, "backgroundColor", "rgba(0 , 0 , 0 , .8)"), _defineProperty(_style, "marginTop", "-25px"), _defineProperty(_style, "display", "inline-block"), _defineProperty(_style, "color", "#fff"), _defineProperty(_style, "fontSize", "14px"), _defineProperty(_style, "borderRadius", "2px"), _defineProperty(_style, "transform", "translateX(-50%) scale(0)"), _defineProperty(_style, "transition", "all .2s ease"), _defineProperty(_style, "transformOrigin", "center center"), _style)
				}
			};
		}
		/*
  	intro : set toast constructor
  */

	}, {
		key: "setToastConstructor",
		value: function setToastConstructor(message) {
			var theme = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "dark";

			var isLight = theme === "light";
			// set bg
			var bgDom = _dom2.default.createDom("div");
			_dom2.default.setStyle(bgDom, this.options.backgroundContainer.style || {});
			bgDom.id = "#toast-message-dom-" + _dom2.default.getRandomNum();
			if (isLight) {
				bgDom.style.backgroundColor = "rgba(50 , 50 , 50 , .6)";
			}
			// set content 
			this.setContentConstructor(bgDom, message, theme);
			this.backgroundContainer = bgDom;
			window.document.body.appendChild(bgDom);
		}
		/*
  	intro : set background Dom
  */

	}, {
		key: "setContentConstructor",
		value: function setContentConstructor(mainDom, message) {
			var theme = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : "dark";

			var isLight = theme === "light";
			var content = _dom2.default.createDom("p");
			_dom2.default.setStyle(content, Object.assign({}, this.options.contentContainer.style || {}, isLight ? { backgroundColor: "#fff", color: "#333" } : {}));
			content.innerHTML = message;
			mainDom.appendChild(content);
			this.setAnimation(content);
		}
		/*
  	intro : setAnimation
  */

	}, {
		key: "setAnimation",
		value: function setAnimation(content) {
			var _this = this;

			new Promise(function (resolve, reject) {
				var interval = setTimeout(function () {
					content.style.transform = "translateX(-50%) scale(1)";
					resolve();
					clearTimeout(interval);
				}, 100);
			}).then(function () {
				var holdTime = setTimeout(function () {
					content.style.opacity = "0";
					content.style.transform = "translateX(-50%) scale(0)";
					var closeT = setTimeout(function () {
						if (_dom2.default.contains(window.document.body, _this.backgroundContainer)) {
							window.document.body.removeChild(_this.backgroundContainer);
							_this.backgroundContainer = null;
						}
					}, 500);
					clearTimeout(holdTime);
				}, _this.options.closeTime);
			});
		}
		/*
  	intro : push toast message
  */

	}, {
		key: "pushMessage",
		value: function pushMessage() {
			var messageHTML = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
			var theme = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "dark";

			if ((0, _reactPureCheck.Types)(messageHTML) !== "string" && (0, _reactPureCheck.Types)(messageHTML) !== "number") {
				(0, _functionComUtils.errorLog)("you should a %s for message", "string");
				return false;
			}
			if ((0, _reactPureCheck.Types)(this.backgroundContainer) !== "null") return;
			this.setToastConstructor(messageHTML, theme);
		}
		/*
  	intro : destory
  */

	}, {
		key: "destory",
		value: function destory() {
			GToastFun.unique = null;
		}
	}]);

	return GToastFun;
}();

;
var GToast = function GToast() {
	var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

	if ((0, _reactPureCheck.Types)(options) !== "object") {
		(0, _functionComUtils.errorBreak)("you should offer a %s for options", "object");
		return false;
	}
	return new GToastFun(options);
};
exports.default = GToast;